diff --git a/gnu/packages/backup.scm b/gnu/packages/backup.scm
index 3126464347..60ce18cc2e 100644
--- a/gnu/packages/backup.scm
+++ b/gnu/packages/backup.scm
@@ -1270,27 +1270,28 @@ (define-public burp
 (define-public disarchive
   (package
     (name "disarchive")
-    (version "0.5.0")
+    (version "0.6.0")
     (source (origin
               (method url-fetch)
               (uri (string-append "https://files.ngyro.com/disarchive/"
                                   "disarchive-" version ".tar.gz"))
               (sha256
                (base32
-                "16sjplkn9nr7zhfrqll7l1m2b2j4hg8k29p6bqjap9fkj6zpn2q2"))))
+                "1s4lyhhh1zsaxgn11hy2b1kdvnvpipii68wba0hwr471rd43m08k"))))
     (build-system gnu-build-system)
     (native-inputs
      (list autoconf
            automake
            pkg-config
            guile-3.0 ;for cross-compilation
+           guile-bzip2
            guile-gcrypt
            guile-lzma
            guile-quickcheck))
     (inputs
      (list guile-3.0 zlib))
     (propagated-inputs
-     (list guile-gcrypt guile-lzma))
+     (list guile-bzip2 guile-gcrypt guile-lzma))
     (home-page "https://ngyro.com/software/disarchive.html")
     (synopsis "Software archive disassembler")
     (description "Disarchive can disassemble software archives into data
diff --git a/gnu/packages/package-management.scm b/gnu/packages/package-management.scm
index 2f6957e9d8..b9870588a7 100644
--- a/gnu/packages/package-management.scm
+++ b/gnu/packages/package-management.scm
@@ -411,11 +411,12 @@ (define-public guix
                                (ssh    (assoc-ref inputs "guile-ssh"))
                                (gnutls (assoc-ref inputs "guile-gnutls"))
                                (disarchive (assoc-ref inputs "disarchive"))
+                               (bzip2 (assoc-ref inputs "guile-bzip2"))
                                (lzma (assoc-ref inputs "guile-lzma"))
                                (locales (assoc-ref inputs "glibc-utf8-locales"))
                                (deps   (list gcrypt json sqlite gnutls git
                                              bs ssh zlib lzlib zstd guile-lib
-                                             disarchive lzma))
+                                             disarchive bzip2 lzma))
                                (deps*  (if avahi (cons avahi deps) deps))
                                (effective
                                 (read-line
@@ -520,6 +521,7 @@ (define-public guix
          ("bootstrap/xz" ,(bootstrap-executable "xz" (%current-system)))
 
          ("disarchive" ,disarchive)               ;for 'guix perform-download'
+         ("guile-bzip2" ,guile-bzip2)             ;for Disarchive
          ("guile-lzma" ,guile-lzma)               ;for Disarchive
 
          ("git-minimal" ,git-minimal)             ;for 'guix perform-download'
diff --git a/guix/self.scm b/guix/self.scm
index f378548959..19c6d08e01 100644
--- a/guix/self.scm
+++ b/guix/self.scm
@@ -65,6 +65,7 @@ (define %packages
       ("guile-gnutls"       . ,(ref 'tls 'guile-gnutls))
       ("guix-daemon"        . ,(ref 'package-management 'guix-daemon))
       ("disarchive"         . ,(ref 'backup 'disarchive))
+      ("guile-bzip2"        . ,(ref 'guile 'guile-bzip2))
       ("guile-lzma"         . ,(ref 'guile 'guile-lzma))
       ("gzip"               . ,(ref 'compression 'gzip))
       ("bzip2"              . ,(ref 'compression 'bzip2))
@@ -827,6 +828,9 @@ (define* (compiled-guix source #:key
   (define disarchive
     (specification->package "disarchive"))
 
+  (define guile-bzip2
+    (specification->package "guile-bzip2"))
+
   (define guile-lzma
     (specification->package "guile-lzma"))
 
@@ -1058,6 +1062,7 @@ (define* (compiled-guix source #:key
                                         #:source source
                                         #:dependencies
                                         (cons* disarchive
+                                               guile-bzip2
                                                guile-lzma
                                                dependencies)
                                         #:guile guile-for-build